<?php
/**
 * @brief dcImageMetaExtender, a plugin for Dotclear 2
 *
 * @package Dotclear
 * @subpackage Plugins
 *
 * @author julien mudry
 *
 * @copyright julien mudry
 * @copyright GPL-2.0 https://www.gnu.org/licenses/gpl-2.0.html
 */
if (!defined('DC_RC_PATH')) { return; }

$this->registerModule(
    "dcImageMetaExtender",
    "Extract more Exif info from an image and add it to the image meta",
    "julien mudry",
    '0.2.0',
    [
        'requires'    => [['core', '2.24']],
        'permissions' => dcCore::app()->auth->makePermissions([
            dcAuth::PERMISSION_USAGE,
            dcAuth::PERMISSION_CONTENT_ADMIN,
        ]),
        'type'        => 'plugin',
        'settings'    => [
            'self'    => '',
        ],
        'priority'    => 9000,
        'details'     => 'https://mudry.org/blog/alias/dcImageMetaExtender',
        'support'     => 'https://codeberg.org/julmud/dc2-dcImageMetaExtender',
    ]
);
