<?php
/**
 * @brief dcImageMetaExtender, a plugin for Dotclear 2
 *
 * @package Dotclear
 * @subpackage Plugins
 *
 * @author julien mudry
 *
 * @copyright julien mudry
 * @copyright GPL-2.0 https://www.gnu.org/licenses/gpl-2.0.html
 */
if (!defined('DC_CONTEXT_ADMIN')) {
    return;
}

if (!dcCore::app()->newVersion(basename(__DIR__), dcCore::app()->plugins->moduleInfo(basename(__DIR__), 'version'))) {
    return;
}

try {
    // Insert below necessary initialisations and updates

    $name = 'dcImageMetaExtender';
    if (!array_key_exists($name, dcCore::app()->blog->settings->dumpNamespaces())) {
        // Inserting default values
        $settingValue[] = array('exif' => 'GPSLongitude', 'name' => 'NumericLongitude', 'transform' => 2);
        $settingValue[] = array('exif' => 'GPSLongitude', 'name' => 'StringLongitude', 'transform' => 1);
        $settingValue[] = array('exif' => 'GPSLatitude', 'name' => 'NumericLatitude', 'transform' => 2);
        $settingValue[] = array('exif' => 'GPSLatitude', 'name' => 'StringLatitude', 'transform' => 1);
        dcCore::app()->blog->settings->addNamespace($name);
        dcCore::app()->blog->settings->$name->put('extendInfo', serialize($settingValue), 'string', 'dcImageMetaExtender information about which data to extract', true, true);
      }

    $old_version = dcCore::app()->getVersion(basename(__DIR__));
    if (version_compare((string) $old_version, '0.1.4', '<')) {
        ; // Update since 0.1.4 to be completed
    }

    return true;
} catch (Exception $e) {
    dcCore::app()->error->add($e->getMessage());
}

return false;
