<?php
$part = !empty($_GET['part']) ? $_GET['part'] : 'options';

if (!empty($_POST['saveconfig'])) {
    $msg = 'Saved configuration';
    try {
#myLog::log('Post: '.print_r($_POST, true));
        foreach ($_POST['property'] as $key => $value) {
            if ($value != '') {
                $name = $_POST['name'][$key] != '' ? $_POST['name'][$key] : $value;
                $settingValue[] = array('exif' => $value, 'name' => $name, 'transform' => $_POST['transform'][$key]);
            }
        }
#myLog::log('setting: '.print_r($settingValue, true));
        dcCore::app()->blog->settings->addNamespace('dcImageMetaExtender');
        dcCore::app()->blog->settings->dcImageMetaExtender->put('extendInfo', serialize($settingValue), 'string', 'dcImageMetaExtender information about which data to extract');
        http::redirect(dcCore::app()->admin->getPageURL().'&up=1&part=options');
    } catch (Exception $e) {
        dcCore::app()->error->add($e->getMessage());
    }
}

try {
    $settingValue = unserialize(dcCore::app()->blog->settings->dcImageMetaExtender->extendInfo);
#myLog::log('read setting: '.$settingValue);
    if ($settingValue == '') { $settingValue = array(); }
} catch (Exception $e) {
#myLog::log('defaulting to empty array for settingValue');
    $settingValue = array();
}
?>
<html>
<head>
    <title><?php echo __('Image Meta Extender'); ?></title>
    <?php echo dcPage::jsPageTabs($part); ?>
    <script type="text/javascript">
        function updateTableControls() {
            $('td.controls').each(function() {
                $(this).html('<img src="index.php?pf=dcImageMetaExtender/delete.png" class="deleteRow" alt="<?php echo __('Remove row'); ?>" title="<?php echo __('Remove row'); ?>" />');
            });
            $('td.controls:last').each(function() {
                $(this).html($(this).html() + ' <img src="index.php?pf=dcImageMetaExtender/add.png" class="addRow" onclick="addRow()" alt="<?php echo __('Add a new row'); ?>" title="<?php echo __('Add a new row'); ?>" />');
            });
            $('#exifSettings td img.deleteRow').click(function() {
                removeRow($(this));
                return false();
            });
        }
        function addRow() {
            $('#exifSettings tr:last').after('<tr>' +
                '<td><?php echo preg_replace('/\R/u', '', form::field('property[]', 25, false)); ?></td>' +
                '<td><?php echo preg_replace('/\R/u', '', form::field('name[]', 25, false)); ?></td>' +
                '<td><?php echo preg_replace('/\R/u', '', form::combo('transform[]', dcImageMetaExtender::transformArray())); ?></td>' +
                '<td class="controls">&nbsp;</td></tr>');
            $('#exifSettings tr:last').hide();
            $('#exifSettings tr:last').fadeIn(400);
            updateTableControls();
            return false;
        }
        function removeRow(img) {
            img.parent().parent().fadeOut(400, function() {
                $(this).remove();
                updateTableControls();
            });
        }
        $(document).ready(function() {
            updateTableControls();
        });
    </script>
</head>
<body>
    <h2><?php echo html::escapeHTML(dcCore::app()->blog->name).' &rsaquo; '.
        __('Image Meta Extender'); ?></h2>

<?php
        if(!empty($_GET['up'])) {
            echo '    <p class="message">'.__('Settings have been successfully updated.').'</p>';
        }
        if(!empty($msg)) {
            echo '    <p class="message">'.$msg.'</p>';
        }
?>

    <div class="multi-part" id="options" title="<?php echo __('Options'); ?>">
        <form method="post" action="plugin.php">
            <table id="exifSettings">
                <thead>
                    <tr><td><?php echo __('Exif property'); ?></td><td><?php echo __('Meta name'); ?></td><td><?php echo __('Data transformation'); ?></td><td>&nbsp;</td></tr>
                </thead>
                <tbody>
<?php
    foreach ($settingValue as $value) {
        echo "                    <tr>\n";
        echo "                        <td>".form::field('property[]', 25, false, $value['exif'])."</td>\n";
        echo "                        <td>".form::field('name[]', 25, false, $value['name'])."</td>\n";
        echo "                        <td>".form::combo('transform[]', dcImageMetaExtender::transformArray(), $value['transform'])."</td>\n";
        echo "                        <td class=\"controls\">&nbsp;</td>\n";
        echo "                    </tr>\n";
  }
?>
                    <tr>
                        <td><?php echo form::field('property[]', 25, false); ?></td>
                        <td><?php echo form::field('name[]', 25, false); ?></td>
                        <td><?php echo form::combo('transform[]', dcImageMetaExtender::transformArray()); ?></td>
                        <td class="controls">&nbsp;</td>
                    </tr>
                </tbody>
            </table>
            <p><input type="hidden" name="p" value="dcImageMetaExtender" />
                <input type="submit" name="saveconfig" value="<?php echo __('Save configuration'); ?>" />
                <?php echo dcCore::app()->formNonce(); ?></p>
            <p><?php echo __('Note: When setting a new property, the Exif property field must have a value. If the Meta name field is left empty, it will use the Exif property name.'); ?></p>
        </form>
    </div>

    <div class="multi-part" id="changelog" title="<?php echo __('Changelog'); ?>">
        <h3>Version 0.2.0</h3>
        <p><?php echo sprintf(__('Released on %s'), '2022-12-26'); ?></p>
        <ul>
            <li><?php echo __('Compatibility with Dotclear 2.24.'); ?></li>
            <li><?php echo __('Fixed a bug in the Javascript code preventing addition or deletion of properties in the settings.'); ?></li>
        </ul>
        <h3>Version 0.1.4</h3>
        <p><?php echo sprintf(__('Released on %s'), '2012-04-14'); ?></p>
        <ul>
            <li><?php echo __('Added support for IPTC data.'); ?></li>
        </ul>
        <h3>Version 0.1.3</h3>
        <p><?php echo sprintf(__('Released on %s'), '2010-10-25'); ?></p>
        <ul>
            <li><?php echo __('Prevent some errors.'); ?></li>
        </ul>
        <h3>Version 0.1.2</h3>
        <p><?php echo sprintf(__('Released on %s'), '2010-10-16'); ?></p>
        <ul>
            <li><?php echo __('Transformation of GPS coordinates as string or number where previously inverted (ie selecting asString in the user interface gave numerical coordinates).'); ?></li>
        </ul>
        <h3>Version 0.1.1</h3>
        <p><?php echo sprintf(__('Released on %s'), '2010-10-12'); ?></p>
        <ul>
            <li><?php echo __('Corrected a bug in GPS coordinates calculations.'); ?></li>
        </ul>
        <h3>Version 0.1.0</h3>
        <p><?php echo sprintf(__('Released on %s'), '2010-10-11'); ?></p>
        <ul>
            <li><?php echo __('Can now extract any EXIF properties, based on configuration done by the admin.'); ?></li>
            <li><?php echo __('Better GPS coordinates calculations.'); ?></li>
        </ul>
        <h3>Version 0.0.2</h3>
        <p><?php echo sprintf(__('Released on %s'), '2010-10-06'); ?></p>
        <ul>
            <li><?php echo __('First public version'); ?></li>
            <li><?php echo __('Works only on GPS EXIF data'); ?></li>
        </ul>
        <h3>Version 0.0.1</h3>
        <p><?php echo __('Never released publicly'); ?></p>
        <ul>
            <li><?php echo __('Development version'); ?></li>
        </ul>
    </div>

    <div class="copyright" style="margin-top:2em;">
        <h4><?php echo __('Copyright information'); ?></h4>
        <p><?php echo sprintf(__('The icons used for this plugin are by %s and distributed under a CC-BY license.'), '<a href="http://www.famfamfam.com/lab/icons/silk/">famfamfam</a>'); ?>
            <?php echo sprintf(__('All the code is %s 2010-2022 by %s.'), '&copy;', '<a href="http://www.mudry.org/">julien mudry</a>'); ?></p>
    </div>
</body>
</html>
